package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.OaCustomer;
import com.ruoyi.oa.domain.vo.OaCustomerVo;
import com.ruoyi.oa.domain.bo.OaCustomerBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * CRM 客户Service接口
 *
 * @author ruoyi
 * @date 2025-03-12
 */
public interface IOaCustomerService {

    /**
     * 查询CRM 客户
     */
    OaCustomerVo queryById(Long customerId);

    /**
     * 查询CRM 客户列表
     */
    TableDataInfo<OaCustomerVo> queryPageList(OaCustomerBo bo, PageQuery pageQuery);

    /**
     * 查询CRM 客户列表
     */
    List<OaCustomerVo> queryList(OaCustomerBo bo);

    /**
     * 新增CRM 客户
     */
    Boolean insertByBo(OaCustomerBo bo);

    /**
     * 修改CRM 客户
     */
    Boolean updateByBo(OaCustomerBo bo);

    /**
     * 校验并批量删除CRM 客户信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 查询已分配的用户
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<OaCustomerVo> queryPageListToUser(OaCustomerBo bo, PageQuery pageQuery);

    /**
     * 查询公海中的客户
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<OaCustomerVo> queryPageListToSea(OaCustomerBo bo, PageQuery pageQuery);
}
